Loading...
Searching...
No Matches
AVClass Struct Reference

Describe the class of an AVClass context structure. More...

`#include <libavutil/log.h>`

## Data Fields

const char * | class_name
| The name of the class; usually it is the same name as the context structure type to which the AVClass is associated.
const char *(* | item_name )(void *ctx)
| A pointer to a function which returns the name of a context instance ctx associated with the class.
const struct AVOption * | option
| a pointer to the first option specified in the class if any or NULL
int | version
| LIBAVUTIL_VERSION with which this structure was created.
int | log_level_offset_offset
| Offset in the structure where log_level_offset is stored.
int | parent_log_context_offset
| Offset in the structure where a pointer to the parent context for logging is stored.
AVClassCategory | category
| Category used for visualization (like color) This is only set if the category is equal for all objects using this class.
AVClassCategory(* | get_category )(void *ctx)
| Callback to return the category.
int(* | query_ranges )(struct AVOptionRanges **, void *obj, const char *key, int flags)
| Callback to return the supported/allowed ranges.
void *(* | child_next )(void *obj, void *prev)
| Return next AVOptions-enabled child or NULL.
const struct AVClass *(* | child_class_iterate )(void **iter)
| Iterate over the AVClasses corresponding to potential AVOptions-enabled children.

## Detailed Description

Describe the class of an AVClass context structure.

That is an arbitrary struct of which the first field is a pointer to an AVClass struct (e.g. AVCodecContext, AVFormatContext etc.).

Definition at line 66 of file log.h.

## Field Documentation

## class_name

const char* AVClass::class_name

The name of the class; usually it is the same name as the context structure type to which the AVClass is associated.

Definition at line 71 of file log.h.

## item_name

const char *(* AVClass::item_name) (void *ctx)

A pointer to a function which returns the name of a context instance ctx associated with the class.

Definition at line 77 of file log.h.

## option

const struct AVOption* AVClass::option

a pointer to the first option specified in the class if any or NULL

See also
  av_set_default_options()

Definition at line 84 of file log.h.

## version

int AVClass::version

LIBAVUTIL_VERSION with which this structure was created.

This is used to allow fields to be added without requiring major version bumps everywhere.

Definition at line 92 of file log.h.

## log_level_offset_offset

int AVClass::log_level_offset_offset

Offset in the structure where log_level_offset is stored.

0 means there is no such variable

Definition at line 98 of file log.h.

## parent_log_context_offset

int AVClass::parent_log_context_offset

Offset in the structure where a pointer to the parent context for logging is stored.

For example a decoder could pass its AVCodecContext to eval as such a parent context, which an av_log() implementation could then leverage to display the parent context. The offset can be NULL.

Definition at line 107 of file log.h.

## category

AVClassCategory AVClass::category

Category used for visualization (like color) This is only set if the category is equal for all objects using this class.

available since version (51 << 16 | 56 << 8 | 100)

Definition at line 114 of file log.h.

## get_category

AVClassCategory(* AVClass::get_category) (void *ctx)

Callback to return the category.

available since version (51 << 16 | 59 << 8 | 100)

Definition at line 120 of file log.h.

## query_ranges

int(* AVClass::query_ranges) (struct AVOptionRanges **, void *obj, const char *key, int flags)

Callback to return the supported/allowed ranges.

available since version (52.12)

Definition at line 126 of file log.h.

## child_next

void *(* AVClass::child_next) (void *obj, void *prev)

Return next AVOptions-enabled child or NULL.

Definition at line 131 of file log.h.

## child_class_iterate

const struct AVClass *(* AVClass::child_class_iterate) (void **iter)

Iterate over the AVClasses corresponding to potential AVOptions-enabled children.

Parameters

  iter | pointer to opaque iteration state. The caller must initialize *iter to NULL before the first call.

Returns
  AVClass for the next AVOptions-enabled child or NULL if there are no more such children.

Note
  The difference between child_next and this is that child_next iterates over already existing objects, while child_class_iterate iterates over all possible children.

Definition at line 131 of file log.h.

The documentation for this struct was generated from the following file:

- libavutil/log.h